consistently use ESP label for the EFI system partition
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
12 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
13
14 error_handler() {
15    last_exit_code="$?"
16    last_bash_command="$BASH_COMMAND"
17    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
18       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
19 last bash command: $last_bash_command"
20    fi
21    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
22       return
23    fi
24    ## Check if "bailout" function is available.
25    ## This is not the case in chroot-script.
26    if command -v bailout >/dev/null 2>&1; then
27       bailout 1
28    else
29       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
30       exit 1
31    fi
32 }
33
34 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
35    set -e
36    set -E
37    set -o pipefail
38    trap "error_handler" ERR
39    export -f "error_handler"
40 fi
41 # }}}
42
43 # variables {{{
44 PN="$(basename "$0")"
45 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
46   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
47 else
48   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
49 fi
50 VERSION="${VERSION:-unknown}"
51 MNTPOINT="/mnt/debootstrap.$$"
52
53 # defaults
54 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
55 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
56 [ -n "$DEBCONF" ] || DEBCONF='yes'
57 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
58 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
59 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
60 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
61 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
62 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
63 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
64 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
65 [ -n "$FORCE" ] || FORCE=''
66 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
67 [ -n "$INITRD" ] || INITRD='yes'
68 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
69 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
70 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
71 [ -n "$LOCALES" ] || LOCALES='yes'
72 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
73 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
74 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
75 [ -n "$PACKAGES" ] || PACKAGES='yes'
76 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
77 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
78 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
79 [ -n "$RELEASE" ] || RELEASE='bookworm'
80 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
81 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
82 [ -n "$SECURE" ] || SECURE='yes'
83 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
84 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
85 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
86 [ -n "$VMSIZE" ] || VMSIZE="2G"
87 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
88
89 # inside the chroot system locales might not be available, so use minimum:
90 export LANG=C
91 export LC_ALL=C
92 export LANGUAGE=C
93
94 # make sure interactive mode is only executed when
95 # using an empty configuration file or option --interactive
96 INTERACTIVE=''
97 # }}}
98
99 # help text {{{
100 usage() {
101   echo "$PN - wrapper around debootstrap for installing Debian
102
103 Usage: $PN [options]
104
105 Bootstrap options:
106
107   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
108   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
109                          instead of fetching packages from a mirror.
110   -r, --release <name>   Release of new Debian system (default: bullseye).
111   -t, --target <target>  Target partition (/dev/...) or directory where the
112                          system should be installed to.
113   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
114                          has no effect if -t is given and represents a directory.
115       --debopt <params>  Extra parameters passed to the debootstrap command.
116       --interactive      Use interactive mode (frontend).
117       --nodebootstrap    Skip debootstrap, only do configuration to the target.
118       --grub <device>    Target for grub installation. Usage example: /dev/sda
119       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
120       --arch <arch>      Set target architecture, use for installing i386 on amd64.
121       --filesystem <fs>  Filesystem that should be used when target is a partition
122                          or Virtual Machine (see --vmfile).
123       --force            Do not prompt for user acknowledgement.
124
125 Options for Virtual Machine deployment:
126
127       --vm               Set up a Virtual Machine on an existing block device
128                          instead of plainly installing to a partition or
129                          directory. Needs to be combined with --target.
130                          Example: --vm --target /dev/mapper/your-vm-disk
131       --vmfile           Like --vm, but install into a regular file (created by
132                          'qemu-img create -f raw ...') instead.
133                          Example: --vmfile --target /mnt/sda1/qemu.img
134       --vmsize <size>    Use specified size for size of VM file (default: 2G).
135                          Syntax as supported by qemu-img, like: --vmsize 3G
136       --vmefi            Create an EFI boot partition for the VM.
137
138 Configuration options:
139
140   -c, --config <file>      Use specified configuration file, defaults to
141                              /etc/debootstrap/config
142   -d, --confdir <path>     Place of config files for debootstrap, defaults
143                              to /etc/debootstrap
144       --packages <file>    Install packages defined in specified list file
145                              instead of using /etc/debootstrap/packages.
146       --nopackages         Skip installation of packages defined in
147                              /etc/debootstrap/packages
148       --nokernel           Skip installation of default kernel images.
149       --nointerfaces       Do not copy /etc/network/interfaces from host system
150                            to target system.
151                            (This option is automatically enabled when using --vmfile.)
152       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
153                            DHCP for eth0) instead of taking over config from host system.
154       --debconf <file>     Pre-seed packages using specified pre-seed db file.
155       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
156       --backportrepos      Enable Debian's backports repository (backports.debian.org).
157       --keep_src_list      Do not overwrite user provided apt sources.list.
158       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
159       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
160       --hostname <name>    Hostname of Debian system.
161       --nopassword         Do not prompt for the root password.
162       --password <pwd>     Use specified password as password for user root.
163       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
164       --sshcopyid          Use locally available public keys to authorise root login on the target system.
165       --bootappend <line>  Add specified appendline to kernel whilst booting.
166       --chroot-scripts <d> Execute chroot scripts from specified directory.
167       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
168       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
169       --remove-configs     Delete grml-debootstrap configuration files from installed system.
170
171 Other options:
172
173   -v, --verbose            Increase verbosity.
174       --debug              Execute in very verbose way.
175   -h, --help               Print this usage information and exit.
176   -V, --version            Show summary of options and exit.
177
178 Usage examples can be found in the grml-debootstrap manpage.
179 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
180 "
181 }
182
183 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
184    usage
185    echo 'Please notice that this script requires root permissions!'
186    exit 0
187 fi
188 # }}}
189
190 # early helper functions {{{
191 # skip colors when running within a dumb terminal
192 if [ "${TERM}" = "dumb" ] ; then
193   GOOD=
194   BAD=
195   WARN=
196   NORMAL=
197 else
198   GOOD='\e[32;01m'
199   BAD='\e[31;01m'
200   WARN='\e[33;01m'
201   NORMAL='\e[0m'
202 fi
203
204 einfo() {
205   einfon "$1\\n"
206   return 0
207 }
208
209 einfon() {
210   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
211   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
212   LAST_E_CMD=einfon
213   return 0
214 }
215
216 ewarn() {
217   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
218   return 0
219 }
220
221 eerror() {
222   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
223   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
224   LAST_E_CMD=eerror
225   return 0
226 }
227
228 eend() {
229   local retval="${1:-0}"
230   shift
231   if [ "$retval" -gt 0 ]; then
232     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
233   fi
234   return "$retval"
235 }
236
237 check4root(){
238   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
239     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
240   fi
241 }
242
243 check4progs(){
244   local RC=''
245   for arg in "$@" ; do
246     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
247   done
248   if [ -n "$RC" ] ; then
249      echo "$RC not installed"
250      return 1
251   fi
252 }
253 # }}}
254
255 # helper functions {{{
256 cleanup() {
257   if [ -n "$CHROOT_VARIABLES" ] ; then
258     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
259   fi
260
261   if [ -n "$STAGES" ] ; then
262     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
263   fi
264
265   if [ -n "$ARM_EFI_TARGET" ]; then
266     umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
267   fi
268
269   # Remove temporary mountpoint again
270   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
271     rmdir "$MNTPOINT" 2>/dev/null
272   fi
273
274   # make sure $TARGET is not mounted when exiting grml-debootstrap
275   if [ -n "$MNTPOINT" ] ; then
276     if grep -q "$MNTPOINT" /proc/mounts ; then
277       # make sure nothing is left inside chroot so we can unmount it
278       for service in ssh mdadm ; do
279         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
280           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
281         fi
282       done
283
284       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
285
286       # ugly, but make sure we really don't leave anything (/proc /proc and
287       # /dev /dev are intended, trying to work around timing issues, see #657023)
288       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
289         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
290         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
291       done
292
293       if [ -n "$ISODIR" ] ; then
294         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
295       fi
296
297       if [ -n "$DIRECTORY" ] ; then
298         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
299       else
300         einfo "Unmounting $MNTPOINT"
301         umount "$MNTPOINT"
302         eend $?
303       fi
304
305       if [ -n "$STAGES" ] ; then
306         echo -n "Removing stages directory ${STAGES}: "
307         rm -rf "$STAGES" && echo 'done'
308       fi
309
310       # remove directory only if we used the default with process id inside the name
311       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
312         einfo "Removing directory ${MNTPOINT}"
313         rmdir "$MNTPOINT"
314         eend $?
315       fi
316     fi
317   fi
318
319   if [ -n "${ORIG_TARGET}" ] ; then
320     einfo "Removing loopback mount of file ${ORIG_TARGET}."
321     kpartx -d "${ORIG_TARGET}"
322     # Workaround for a bug in kpartx which doesn't clean up properly,
323     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
324     if dmsetup ls | grep -q "^${LOOP_PART} "; then
325       kpartx -d "/dev/${LOOP_DISK}" >/dev/null
326     fi
327     eend $?
328   fi
329 }
330
331 # we want to exit smoothly and clean:
332 bailout(){
333
334   cleanup
335
336   [ -n "$1" ] && EXIT="$1" || EXIT="1"
337   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
338
339   exit "$EXIT"
340 }
341 trap bailout HUP INT QUIT TERM
342
343 # we want to execute all the functions only once, simple check for it:
344 stage() {
345   if [ -n "$2" ] ; then
346      echo "$2" > "${STAGES}/${1}"
347      return 0
348   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
349      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
350      ewarn "  To reexecute it clean up the according directory inside $STAGES"
351      return 1
352   fi
353 }
354 # }}}
355
356 # source main configuration file {{{
357 if [ -r /etc/debootstrap/config ] ; then
358   # shellcheck disable=SC1091
359   . /etc/debootstrap/config
360 fi
361 # }}}
362
363 # cmdline handling {{{
364 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
365
366 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
367   $CMDLINE_OPTS -- "$@")
368
369 if [ $? != 0 ]; then
370   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
371 fi
372 eval set -- "$_opt_temp"
373
374 while :; do
375   case "$1" in
376
377   # == Bootstrap options
378   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
379     shift; _opt_mirror="$1"
380     ;;
381   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
382     shift; _opt_iso="$1"
383     ;;
384   --release|-r)        # Release of new Debian system
385     shift; _opt_release="$1"
386     ;;
387   --target|-t)         # Target partition (/dev/...) or directory
388     shift; _opt_target="$1"
389     ;;
390   --vm)                # Virtual machine image (no file)
391     _opt_vm="T"
392     ;;
393   --vmfile)            # Virtual machine file
394     _opt_vmfile="T"
395     ;;
396   --vmsize)            # size of Virtual machine file
397     shift; _opt_vmsize="$1"
398     ;;
399   --vmefi)            # Create an EFI boot partition for the VM
400     _opt_vmefi="T"
401     ;;
402   --mntpoint|-p)       # Mountpoint used for mounting the target system
403     shift; _opt_mntpoint="$1"
404     ;;
405   --debopt)            # Extra parameters passed to the debootstrap command
406     shift; _opt_debopt="$1"
407     ;;
408   --filesystem)        # Filesystem that should be used
409     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
410     ;;
411   --interactive)       # Use interactive mode (frontend)
412     _opt_interactive=T
413     ;;
414   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
415     _opt_nodebootstrap=T
416     ;;
417   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
418     _opt_nopackages=T
419     ;;
420   --arch)              # Target architecutre
421     shift; _opt_arch="$1"
422     ;;
423   # just for backwards compatibility
424   --insecure)
425     _opt_insecure=T
426     ;;
427   #
428
429   # == Configuration options
430   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
431     shift; _opt_config="$1"
432     ;;
433   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
434     shift; _opt_confdir="$1"
435     ;;
436   --packages)          # Install packages defined in specified file
437     shift; _opt_packages="$1"
438     _opt_packages_set=T
439     ;;
440   --debconf)           # Pre-seed packages using specified file
441     shift; _opt_debconf="$1"
442     _opt_debconf_set=T
443     ;;
444   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
445     shift; _opt_pre_scripts="$1"
446     _opt_pre_scripts_set=T
447     ;;
448   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
449     shift; _opt_scripts="$1"
450     _opt_scripts_set=T
451     ;;
452   --post-scripts)       # Execute scripts from specified directory
453     shift; _opt_post_scripts="$1"
454     _opt_post_scripts_set=T
455     ;;
456   --chroot-scripts)   # Execute chroot scripts from specified directory
457     shift; _opt_chroot_scripts="$1"
458     _opt_chroot_scripts_set=T
459     ;;
460   --keep_src_list)     # Do not overwrite user provided apt sources.list
461     _opt_keep_src_list=T
462     ;;
463   --hostname)          # Hostname of Debian system
464     shift; _opt_hostname="$1"
465     ;;
466   --password)          # Use specified password as password for user root
467     shift; _opt_password="$1"
468     ;;
469   --defaultinterfaces) # Install default /etc/network/interfaces
470     _opt_defaultinterfaces=T
471     ;;
472   --nointerfaces)      # Skip installation of /etc/network/interfaces
473     _opt_nointerfaces=T
474     ;;
475   --nokernel)          # Skip installation of default kernel images
476     _opt_nokernel=T
477     ;;
478   --nopassword)        # Skip password dialog
479     _opt_nopassword=T
480     ;;
481   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
482     _opt_sshcopyid=T
483     ;;
484   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
485     _opt_sshcopyauth=T
486     ;;
487   --grmlrepos)         # Enable Grml repository
488     _opt_grmlrepos=T
489     ;;
490   --backportrepos)     # Enable Debian backports repository
491     _opt_backportrepos=T
492     ;;
493   --bootappend)        # Add specified appendline to kernel whilst booting
494     shift; _opt_bootappend="$1"
495     ;;
496   --grub)              # Target for grub installation. Use grub syntax for specifying
497     shift; _opt_grub="$1"
498     ;;
499   --efi)               # Target for EFI boot installation
500     shift; _opt_efi="$1"
501     ;;
502   --contrib)           # Add 'contrib' to list of components
503     _opt_contrib=T
504     ;;
505   --non-free)          # Add 'non-free' to list of components
506     _opt_non_free=T
507     ;;
508   --remove-configs)    # Drop config files from installed system
509     _opt_remove_configs=T
510     ;;
511
512   # == Other options
513   --verbose|-v)        # Increase verbosity
514     if [ "$_opt_verbose" ]; then
515       _opt_verbose=$( _opt_verbose + 1 )
516     else
517       _opt_verbose=1
518     fi
519     ;;
520   --debug)             # Execute in debug mode
521     _opt_debug=T
522     ;;
523   --help|-h)           # Print usage information and exit
524     _opt_help=T
525     ;;
526   --version|-V)        # Show version information and exit
527     _opt_version=T
528     ;;
529   --force)             # Do not prompt for user input
530     _opt_force=T
531     ;;
532   --)
533     shift; break
534     ;;
535   *)
536     eerror "Internal getopt error!"; eend 1 ; exit 1
537     ;;
538   esac
539   shift
540 done
541
542 # == business-logic of command line parameter-processing
543
544 # source configuration file in <confdir> if supplied. {{{
545 [ "$_opt_confdir" ] && {
546   CONFFILES=$_opt_confdir
547   einfo "Using config files under $CONFFILES/."
548   if ! [ -r "$CONFFILES/config" ] ; then
549     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
550   fi
551   # shellcheck disable=SC1091 source=config
552   if ! . "$CONFFILES/config" ; then
553     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
554   fi
555   # restore the command line parameter value
556   CONFFILES=$_opt_confdir
557 }
558 # }}}
559
560 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
561 [ "$_opt_iso" ]                 && ISO=$_opt_iso
562 [ "$_opt_release" ]             && RELEASE=$_opt_release
563 [ "$_opt_target" ]              && TARGET=$_opt_target
564 [ "$_opt_vm" ]                  && VIRTUAL=1
565 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
566 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
567 [ "$_opt_vmefi" ]               && VMEFI=1
568 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
569 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
570 [ "$_opt_interactive" ]         && INTERACTIVE=1
571 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
572 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
573 [ "$_opt_packages_set" ]        && PACKAGES='yes'
574 [ "$_opt_nopackages" ]          && PACKAGES=''
575 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
576 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
577 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
578 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
579 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
580 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
581 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
582 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
583 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
584 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
585 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
586 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
587 [ "$_opt_nokernel" ]            && NOKERNEL="true"
588 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
589 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
590 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
591 [ "$_opt_grub" ]                && GRUB=$_opt_grub
592 [ "$_opt_efi" ]                 && EFI=$_opt_efi
593 [ "$_opt_arch" ]                && ARCH=$_opt_arch
594 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
595 [ "$_opt_force" ]               && FORCE=$_opt_force
596 [ "$_opt_verbose" ]             && VERBOSE="-v"
597 [ "$_opt_debug" ]               && DEBUG="true"
598 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
599
600 # make sure main is always included
601 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
602 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
603
604 case "${RELEASE}" in
605   jessie|stretch|buster|bullseye)
606     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
607     ;;
608   *)
609     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
610     ;;
611 esac
612
613 # command line option checks
614 if [ "$_opt_scripts_set" ] ; then
615   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
616   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
617 fi
618
619 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
620   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
621   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
622   eend 1
623   bailout 1
624 fi
625
626 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
627   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
628   eend 1
629   bailout 1
630 fi
631
632 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
633   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
634   eerror "Either drop the --iso ... option or use plain debootstrap instead."
635   eend 1
636   bailout 1
637 fi
638
639 if [ "$DEBUG" = "true" ] ; then
640   set -x
641 fi
642
643 [ "$_opt_help" ] && {
644   usage
645   exit 0
646 }
647
648 [ "$_opt_version" ] && {
649   einfo "$PN - version $VERSION"
650   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
651   exit 0
652 }
653 # }}}
654
655 # check for root permissions {{{
656 if ! check4root ; then
657    echo "For usage instructions please execute '$PN --help'."
658    bailout 1
659 fi
660 # }}}
661
662 # make sure we have what we need {{{
663 check4progs "${DEBOOTSTRAP}" || bailout 1
664
665 if [ -n "$VIRTUAL" ] ; then
666   check4progs kpartx parted qemu-img || bailout 1
667 fi
668 # }}}
669
670 # source specified configuration file {{{
671 if [ -n "$CONFIGFILE" ] ; then
672   einfo "Reading specified config file $CONFIGFILE."
673   # shellcheck disable=SC1091 source=config
674   if ! . "$CONFIGFILE" ; then
675     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
676   fi
677 fi
678 # }}}
679
680 # backwards compatibility checks {{{
681 if [ -n "$GROOT" ] ; then
682    eerror "Error: you seem to have \$GROOT configured."
683    eerror "This variable is no longer supported, please visit the"
684    eerror "grml-debootstrap documentation for details."
685    eend 1
686    bailout 1
687 fi
688
689 if echo "$GRUB" | grep -q '^hd' ; then
690    eerror "Error: this syntax for the grub configuration variable is no longer supported."
691    eerror "Please do not use hd... any longer but /dev/sdX instead."
692    eend 1
693    bailout 1
694 fi
695 # }}}
696
697 # welcome screen {{{
698 welcome_dialog()
699 {
700    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
701 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
702 }
703 # }}}
704
705 # ask for target {{{
706 prompt_for_target()
707 {
708   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
709                sed 's/*//' | \
710                grep -v 'Extended$' | \
711                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
712
713   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
714      dialog --title "$PN" --trim \
715      --msgbox "Sorry, no partitions found. Please configure your
716      harddisks (see /proc/partitions) using a tool like fdisk,
717      cfdisk, gpart, gparted,..." 0 0
718      bailout 1
719   fi
720
721   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
722                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
723                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
724                      echo "$i" "$fs"
725                      unset fs
726                    done)
727
728   # shellcheck disable=SC2086
729   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
730          --menu "Please select the target partition:" 0 0 0 \
731          $PARTITION_LIST)
732   [ $? -eq 0 ] || bailout 1
733 }
734 # }}}
735
736 # ask for bootmanager {{{
737 prompt_for_bootmanager()
738 {
739   ADDITIONAL_PARAMS=""
740
741   if echo "$TARGET" | grep -q "/dev/md" ; then
742      MBRPART="all disks of Software RAID $TARGET"
743   else
744      # figure out whole disk device
745      found=
746      for device in /dev/disk/by-id/*
747      do
748         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
749         found=1
750         break
751      done
752      # shellcheck disable=SC2001
753      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
754      if [ -e "$MBRDISK" ]; then
755         MBRDISK=$(readlink -f "$MBRDISK")
756      else
757         # fall back to old behaviour
758         # shellcheck disable=SC2001
759         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
760      fi
761
762      MBRPART="MBR of $MBRDISK"
763   fi
764
765   for device in cciss/c0d0 sda hda; do
766     if [ "/dev/$device" != "${MBRDISK}" ]; then
767       grep -q $device /proc/partitions && \
768       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
769     fi
770   done
771   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
772
773   OIFS="$IFS"; IFS=:
774
775   # shellcheck disable=SC2086
776   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
777           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
778             mbr       "install bootmanager into $MBRPART" \
779             nowhere   "do not install bootmanager at all" \
780           ${ADDITIONAL_PARAMS})
781   [ $? -eq 0 ] || bailout 3
782   IFS="$OIFS"
783
784   case "$GETMBR" in
785     mbr)
786       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
787       if echo "$TARGET" | grep -q "/dev/md" ; then
788         GRUB="$TARGET"
789       else
790         GRUB="$MBRDISK"
791       fi
792       ;;
793     hda)
794       GRUB="/dev/hda"
795       ;;
796     sda)
797       GRUB="/dev/sda"
798       ;;
799     nowhere)
800       GRUB=''
801       ;;
802   esac
803 }
804 # }}}
805
806 # ask for Debian release {{{
807 prompt_for_release()
808 {
809   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
810   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
811             "Please enter the Debian release you would like to use for installation:" \
812             0 50 8 \
813             buster   Debian/10 \
814             bullseye Debian/11 \
815             bookworm Debian/12 \
816             sid      Debian/unstable)"
817   [ $? -eq 0 ] || bailout
818 }
819 # }}}
820
821 # ask for hostname {{{
822 prompt_for_hostname()
823 {
824   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
825             "Please enter the hostname you would like to use for installation:" \
826             0 0 "$HOSTNAME")"
827   [ $? -eq 0 ] || bailout
828 }
829 # }}}
830
831 # ask for password {{{
832 prompt_for_password()
833 {
834   if [ "$_opt_nopassword" ] ; then
835     einfo "Skip asking for root password as requested."
836     return 0
837   fi
838
839   ROOTPW1='PW1'
840   ROOTPW2='PW2'
841   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
842     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
843     "Please enter the password for the root account:" 10 60)
844     [ $? -eq 0 ] || bailout
845
846     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
847     "Please enter the password for the root account again for \
848     confirmation:" 10 60)
849     [ $? -eq 0 ] || bailout
850
851     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
852       dialog --stdout --title "${PN}" --ok-label \
853         "Retry" --msgbox "Passwords do not match!" 10 60
854     fi
855   done
856   ROOTPASSWORD="$ROOTPW1"
857 }
858 # }}}
859
860 # ask for Debian mirror {{{
861 prompt_for_mirror()
862 {
863   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
864
865   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
866           --menu "Where do you want to install from?" 0 0 0 \
867             net   "install via network (downloading from mirror)" \
868             local "install from local directory/mirror"
869           )
870   [ $? -eq 0 ] || bailout
871
872   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
873      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
874      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
875                "Please enter Debian mirror you would like to use for installing packages." \
876                0 0 $MIRROR)"
877      [ $? -eq 0 ] || bailout
878   else # CHOOSE_MIRROR == local
879      [ -n "$ISO" ] || ISO='/mnt/mirror'
880      ISO="$(dialog --stdout --title "${PN}" --inputbox \
881                "Please enter directory name you would like to use for installing packages." \
882                0 0 $ISO)"
883      [ $? -eq 0 ] || bailout
884   fi
885 }
886 # }}}
887
888 # software raid setup {{{
889 config_swraid_setup()
890 {
891 TMPFILE=$(mktemp)
892
893 # Currently we support only raid1:
894 RAIDLEVEL='raid1'
895
896 MD_LIST=$(for i in $(seq 0 9) ; do
897             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
898             echo "/dev/md$i /dev/md$i"
899           done)
900
901 # shellcheck disable=SC2086
902 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
903 --menu "Which device do you want to use for ${RAIDLEVEL}?
904
905 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
906 $MD_LIST)
907 [ $? -eq 0 ] || bailout 20
908
909 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
910              sed 's/*//' | \
911              grep -v 'Extended$' | \
912              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
913 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
914 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
915                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
916                  done)
917
918 # shellcheck disable=SC2086
919 dialog --title "$PN" --separate-output \
920        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
921        $PARTITION_LIST 2>"$TMPFILE"
922 [ $? -eq 0 ] || bailout
923 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
924
925 NUM_PARTITIONS=0
926 while IFS= read -r i; do
927   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
928 done < "$TMPFILE"
929
930 ERRORFILE=$(mktemp)
931 # shellcheck disable=SC2086
932 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
933       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
934 RC=$?
935 if [ "$RC" = 0 ] ; then
936    dialog --title "$PN" --msgbox \
937    "Creating $TARGET was successful." 0 0
938    rm -f "$TMPFILE" "$ERRORFILE"
939 else
940    dialog --title "$PN" --msgbox \
941    "There was an error setting up $TARGET:
942
943 $(cat "$ERRORFILE")
944
945 Exiting." 0 0
946    rm -f "$TMPFILE" "$ERRORFILE"
947    bailout 1
948 fi
949
950 }
951
952 prompt_for_swraid()
953 {
954 if dialog --stdout --title "$PN" \
955           --defaultno --yesno "Do you want to configure Software RAID?
956
957 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
958   config_swraid_setup
959 fi
960 }
961 # }}}
962
963 # user should recheck his configuration {{{
964 # support full automatic installation:
965 checkforrun() {
966    dialog --timeout 10 --title "$PN" \
967           --yesno "Do you want to stop at this stage?
968
969 Notice: you are running ${PN} in non-interactive mode.
970 ${PN} will install Debian ${RELEASE} on ${TARGET}.
971 Last chance to quit. Timeout of 10 seconds running....
972
973 Do you want to stop now?" 0 0 2>/dev/null
974 }
975 # }}}
976
977 # format efi partition {{{
978 format_efi_partition() {
979   if [ -z "$EFI" ] ; then
980     return 0
981   fi
982
983   if ! [ -b "$EFI" ] ; then
984     eerror "Specified efi argument [$EFI] not a valid block device."
985     bailout 1
986   fi
987
988   if fsck.vfat -bn "$EFI" >/dev/null; then
989     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
990   else
991     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
992     mkfs.fat -F32 -n "EFI" "$EFI"
993     RC=$?
994     if [ ! $RC -eq 0 ] ; then
995       eerror "Error while creating filesystem on ${EFI}."
996       eend 1
997       bailout 1
998     fi
999   fi
1000 }
1001 # }}}
1002
1003 # check for EFI support or try to enable it {{{
1004 efi_support() {
1005   local efivars_loaded=false
1006   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
1007   if modprobe efivars &>/dev/null ; then
1008     efivars_loaded=true
1009   fi
1010   # kernel versions v3.10 and newer usually provide efivarfs
1011   if modprobe efivarfs &>/dev/null ; then
1012     efivars_loaded=true
1013   fi
1014
1015   if [ -d /sys/firmware/efi ] ; then
1016     einfo "EFI support detected."
1017     return 0
1018   fi
1019
1020   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
1021     einfo "EFI support detected, but system seems to be running in BIOS mode."
1022   fi
1023
1024   return 1
1025 }
1026 # }}}
1027
1028 # make sure the user is aware of the used configuration {{{
1029 checkconfiguration()
1030 {
1031
1032 if [ -z "$VIRTUAL" ] ; then
1033   if efi_support ; then
1034     if [ -z "$_opt_efi" ] ; then
1035       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1036     fi
1037   else
1038     if [ -n "$_opt_efi" ] ; then
1039       eerror "EFI option used but no EFI support detected."
1040       bailout 1
1041     fi
1042   fi
1043 fi
1044
1045 if [ -n "$AUTOINSTALL" ] ; then
1046    if checkforrun ; then
1047       eerror "Exiting as requested"
1048       bailout 1
1049    fi
1050 elif [ -n "$INTERACTIVE" ] ; then
1051
1052    INFOTEXT="Please recheck configuration before execution:
1053    "
1054    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1055    Target:          $TARGET"
1056    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1057    Install grub:    $GRUB"
1058    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1059    Install efi:     $EFI"
1060    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1061    Using release:   $RELEASE"
1062    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1063    Using hostname:  $HOSTNAME"
1064    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1065    Using mirror:    $MIRROR"
1066    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1067    Using ISO:       $ISO"
1068    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1069    Using arch:      $ARCH"
1070    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1071    Config files:    $CONFFILES"
1072
1073    INFOTEXT="$INFOTEXT
1074
1075 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1076
1077    dialog --title "$PN" --no-collapse \
1078           --yesno "$INFOTEXT" 0 0
1079    [ $? -eq 0 ] || bailout 0
1080
1081 else # if not running automatic installation display configuration and prompt for execution:
1082    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1083    echo
1084    echo "   Target:          $TARGET"
1085
1086    # do not display if MNTPOINT is the default one
1087    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1088
1089    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1090       echo "   Install grub:    yes"
1091       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1092    else
1093      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1094      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1095    fi
1096
1097    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1098    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1099    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1100    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1101    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1102    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1103    if [ -n "$VIRTUAL" ] ; then
1104       echo "   Deploying as Virtual Machine."
1105       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1106          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1107       fi
1108    fi
1109
1110    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1111       echo
1112       echo "   You do not have a TTY allocated, your password will be shown in"
1113       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1114    fi
1115
1116    echo
1117    echo "   Important! Continuing will delete all data from ${TARGET}!"
1118
1119    if [ -n "$FORCE" ] ; then
1120      einfo "Skip user acknowledgement as requested via --force option."
1121    else
1122      echo
1123      einfon "Is this ok for you? [y/N] "
1124      read -r a
1125      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1126         eerror "Exiting as requested." ; eend 1
1127         bailout 1
1128      fi
1129    fi
1130 fi
1131 }
1132 # }}}
1133
1134 # interactive mode {{{
1135 interactive_mode()
1136 {
1137   check4progs dialog || bailout 1
1138
1139   welcome_dialog
1140
1141   prompt_for_release
1142
1143   prompt_for_swraid
1144
1145   prompt_for_target
1146
1147   prompt_for_bootmanager
1148
1149   prompt_for_hostname
1150
1151   prompt_for_password
1152
1153   prompt_for_mirror
1154 }
1155
1156 # run interactive mode if we didn't get the according configuration yet
1157 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1158    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1159    INTERACTIVE=1
1160    interactive_mode
1161 fi
1162 # }}}
1163
1164 # architecture setup {{{
1165 if [ -n "$ARCH" ] ; then
1166    ARCHCMD="--arch $ARCH"
1167    ARCHINFO=" (${ARCH})"
1168 else
1169    ARCH="$(dpkg --print-architecture)"
1170    ARCHCMD="--arch $ARCH"
1171    ARCHINFO=" (${ARCH})"
1172 fi
1173
1174 if [ -z "${ARCH:-}" ] ; then
1175   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1176   eerror 'Consider setting the --arch ... option.' ; eend 1
1177   bailout 1
1178 fi
1179 # }}}
1180
1181 # It is not possible to build amd64 on i686. {{{
1182 CURRENT_ARCH="$(uname -m)"
1183 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1184    if [ "$ARCH" = "amd64" ] ; then
1185       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1186       bailout 1
1187    fi
1188 fi
1189 # }}}
1190
1191 # Support for generic release codenames is unavailable. {{{
1192 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1193    eerror "Generic release codenames (stable, testing) are unsupported. \
1194 Please use specific codenames such as bullseye or bookworm." ; eend 1
1195    bailout 1
1196 fi
1197 # }}}
1198
1199 checkconfiguration
1200
1201 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1202 if [ -n "$TARGET" ] ; then
1203    SHORT_TARGET="${TARGET##*/}"
1204 else
1205    eerror "Please adjust $CONFFILES/config or..."
1206    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1207    bailout 1
1208 fi
1209 # }}}
1210
1211 # stages setup {{{
1212 if [ -z "$STAGES" ] ; then
1213    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1214    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1215 fi
1216
1217 if [ -r "$STAGES"/grml-debootstrap ] ; then
1218    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1219       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1220       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1221    fi
1222 fi
1223 # }}}
1224
1225 # partition handling {{{
1226 PARTITION=''
1227 DIRECTORY=''
1228
1229 set_target_directory(){
1230     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1231     DIRECTORY=1
1232     MNTPOINT="$TARGET"
1233     MKFS=''
1234     TUNE2FS=''
1235     FSCK=''
1236     # make sure we normalise the path to an absolute directory name so something like:
1237     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1238     # works
1239     TARGET="$(readlink -f "$TARGET")"
1240 }
1241
1242 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1243     PARTITION=1
1244 else
1245     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1246     if [[ $TARGET == "/dev/"* ]]; then
1247       eerror "Error: Will not create target directory $TARGET in /dev."
1248       eerror "  Please check the partition(s) of the blockdevice."; eend 1
1249       bailout 1
1250     fi
1251     set_target_directory
1252 fi
1253 # }}}
1254
1255 # make sure we have the right syntax when using an iso image {{{
1256 if [ -n "$ISO" ] ; then
1257    case $ISO in
1258       file*) # do nothing
1259       ;;
1260       *)
1261       ISO=file:$ISO
1262       ;;
1263    esac
1264 fi
1265 ISODIR=${ISO##file:}
1266 ISODIR=${ISODIR%%/}
1267 # }}}
1268
1269 # Debian ISOs do not contain signed Release files {{{
1270 if [ -n "$ISO" ] ; then
1271     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1272 fi
1273 # }}}
1274
1275 # create filesystem {{{
1276 mkfs() {
1277   if [ -n "$DIRECTORY" ] ; then
1278      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1279      return 0
1280   fi
1281
1282   if grep -q "$TARGET" /proc/mounts ; then
1283     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1284     bailout 1
1285   fi
1286
1287   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1288   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1289   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1290     case "$MKFS" in
1291       mkfs.ext*)
1292         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1293         MKFS_OPTS="$MKFS_OPTS -F"
1294         ;;
1295     esac
1296   fi
1297
1298   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1299   # by default, which requires a recent version of tune2fs on the target system then,
1300   # so disable this feature for older Debian releases where it's known to be unsupported
1301   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1302     case "$RELEASE" in
1303       jessie)
1304         # assume a more recent version if we can't identify the version via dpkg-query
1305         local e2fsprogs_version
1306         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1307         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1308           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1309           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1310         fi
1311         ;;
1312     esac
1313   fi
1314
1315   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1316   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1317   # Disable this feature for Debian releases older than bookworm
1318   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1319     case "$RELEASE" in
1320       jessie|stretch|buster|bullseye)
1321         local e2fsprogs_version
1322         # assume a more recent version if we can't identify the version via dpkg-query
1323         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1324         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1325           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1326           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1327         fi
1328         ;;
1329     esac
1330   fi
1331
1332   if [ -n "$MKFS" ] ; then
1333
1334     if [ -n "${ARM_EFI_TARGET}" ] ; then
1335       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1336       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1337       eend $?
1338
1339       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1340     fi
1341
1342     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1343     # shellcheck disable=SC2086
1344     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1345
1346     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1347       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1348         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1349         eend 1
1350         bailout 1
1351       else
1352         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1353         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1354         eend $?
1355       fi
1356     fi
1357
1358     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1359       einfo "Creating FAT filesystem on $EFI_TARGET"
1360       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1361       eend $?
1362     fi
1363
1364     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1365     # will fail to detect the uuid in the chroot
1366     if [ -n "$VIRTUAL" ] ; then
1367       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1368     elif echo "$TARGET" | grep -q "/dev/md" ; then
1369       blockdev --rereadpt "${TARGET}"
1370     else
1371       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1372       local main_device="${TARGET%%[0-9]*}"
1373       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1374       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1375         blockdev --rereadpt "$main_device"
1376       else
1377         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1378       fi
1379     fi
1380     # give the system 2 seconds, otherwise we might run into
1381     # race conditions :-/
1382     sleep 2
1383
1384     eend $RC
1385   fi
1386 }
1387 # }}}
1388
1389 # retrieve ID_FS_UUID {{{
1390 identify_target_uuid() {
1391   local device="$1"
1392
1393   if ! [ -b "$device" ] ; then
1394     return 1
1395   fi
1396
1397   eval "$(blkid -o udev "$1" 2>/dev/null)"
1398
1399   if [ -n "$ID_FS_UUID" ] ; then
1400     echo "$ID_FS_UUID"
1401   else
1402     return 1
1403   fi
1404 }
1405 # }}}
1406
1407 # identify TARGET_UUID {{{
1408 mountpoint_to_blockdevice() {
1409   TARGET_UUID=''
1410
1411   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1412   if [ -n "$TARGET_UUID" ] ; then
1413     einfo "Identified UUID $TARGET_UUID for $TARGET"
1414     return 0
1415   fi
1416
1417   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1418   for file in /sys/block/*/*/dev ; do
1419     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1420       local dev
1421       dev="${file%/dev}"
1422       dev="/dev/${dev##*/}"
1423       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1424
1425       if [ -n "$TARGET_UUID" ] ; then
1426         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1427         return 0
1428       fi
1429     fi
1430   done
1431 }
1432 # }}}
1433
1434 # modify filesystem settings {{{
1435 tunefs() {
1436   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1437      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1438      $TUNE2FS "$TARGET" </dev/null
1439      eend $?
1440   fi
1441 }
1442 # }}}
1443
1444 # mount the new partition or if it's a directory do nothing at all {{{
1445 mount_target() {
1446   if [ -n "$DIRECTORY" ] ; then
1447      einfo "Running grml-debootstrap on a directory, nothing to mount."
1448   else
1449      if grep -q "$TARGET" /proc/mounts ; then
1450         ewarn "$TARGET already mounted, continuing anyway."
1451      else
1452        if ! [ -d "${MNTPOINT}" ] ; then
1453           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1454        fi
1455        einfo "Mounting $TARGET to $MNTPOINT"
1456        mkdir -p "$MNTPOINT"
1457        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1458        eend $?
1459      fi
1460   fi
1461   if [ -n "$ISODIR" ] ; then
1462      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1463      mkdir -p "$MNTPOINT/$ISODIR"
1464      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1465      eend $?
1466   fi
1467 }
1468 # }}}
1469
1470 # prepare VM image for usage with debootstrap {{{
1471 prepare_vm() {
1472   if [ -z "$VIRTUAL" ] ; then
1473      return 0 # be quiet by intention
1474   fi
1475
1476   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1477      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1478      eend 1
1479      bailout 1
1480   fi
1481   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1482      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1483      eend 1
1484      bailout 1
1485   fi
1486
1487   # make sure loop module is present and a usable loop device exists
1488   modprobe -q loop
1489   if ! losetup -f >/dev/null 2>&1; then
1490     eerror "Error finding usable loop device" ; eend 1
1491     bailout 1
1492   fi
1493
1494   # if dm-mod isn't available then kpartx will fail with
1495   # "Is device-mapper driver missing from kernel? [...]"
1496   modprobe -q dm-mod
1497   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1498     eerror "Device-mapper support missing in kernel." ; eend 1
1499     bailout 1
1500   fi
1501
1502   ORIG_TARGET="$TARGET" # store for later reuse
1503
1504   if [ -n "$VMFILE" ]; then
1505     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1506   fi
1507   if [ -n "$VMEFI" ]; then
1508     parted -s "${TARGET}" 'mklabel gpt'
1509     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1510     parted -s "${TARGET}" 'set 1 boot on'
1511     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1512     parted -s "${TARGET}" 'set 2 bios_grub on'
1513     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1514
1515   else
1516     # arm64 support largely only exists for GPT
1517     if [ "$ARCH" = 'arm64' ]; then
1518       einfo "Setting up GPT partitions for arm64"
1519       parted -s "${TARGET}" 'mklabel gpt'
1520       parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 10MiB'
1521       parted -s "${TARGET}" 'set 1 boot on'
1522       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1523     else
1524       parted -s "${TARGET}" 'mklabel msdos'
1525       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1526         einfo "Adjusting disk signature to a fixed (non-random) value"
1527         MBRTMPFILE=$(mktemp)
1528         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1529         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1530         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1531         eend $?
1532       fi
1533       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1534       parted -s "${TARGET}" 'set 1 boot on'
1535     fi
1536   fi
1537
1538   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1539   if [ -z "${DEVINFO}" ] ; then
1540     eerror "Error setting up loopback device." ; eend 1
1541     bailout 1
1542   fi
1543
1544   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1545   if [ "$ARCH" = 'arm64' ]; then
1546     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1547     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1548     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1549     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1550     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1551   fi
1552
1553   # hopefully this always works as expected
1554   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1555   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1556   if [ -n "$VMEFI" ]; then
1557     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1558     LOOP_PART="${LOOP_PART%p1}p3"
1559   fi
1560   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1561   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1562
1563   if [ -z "$TARGET" ] ; then
1564      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1565      bailout 1
1566   fi
1567 }
1568 # }}}
1569
1570 # make VM image bootable {{{
1571 grub_install() {
1572   if [ -z "${VIRTUAL}" ] ; then
1573      return 0
1574   fi
1575   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1576     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1577     return 0
1578   fi
1579
1580   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1581     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1582     bailout 1
1583   fi
1584
1585   if [ -n "${ARM_EFI_TARGET}" ]; then
1586     mkdir -p "${MNTPOINT}/boot/efi"
1587     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
1588       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue." ; eend 1
1589       bailout 1
1590     fi
1591   fi
1592
1593   mount -t proc none "${MNTPOINT}"/proc
1594   mount -t sysfs none "${MNTPOINT}"/sys
1595   mount -t devtmpfs udev "${MNTPOINT}"/dev
1596   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1597
1598   if [ -n "$ARM_EFI_TARGET" ]; then
1599     einfo "Installing Grub as bootloader into EFI."
1600
1601     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1602   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1603   # chroot-script skips installation for unset ${GRUB}
1604   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1605     einfo "Installing Grub as bootloader."
1606
1607     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1608       echo "Notice: grub-pc package not present yet, installing it therefore."
1609       # shellcheck disable=SC2086
1610       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1611     fi
1612
1613     mkdir -p "${MNTPOINT}/boot/grub"
1614     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1615       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1616       bailout 1
1617     fi
1618     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1619
1620     if [ -n "$VMEFI" ]; then
1621
1622       mkdir -p "${MNTPOINT}"/boot/efi
1623       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1624
1625       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1626         echo "Notice: shim-signed package not present yet, installing it therefore."
1627         # shellcheck disable=SC2086
1628         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1629       fi
1630
1631       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1632         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1633           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1634           # shellcheck disable=SC2086
1635           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1636         fi
1637         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1638       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1639         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1640           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1641           # shellcheck disable=SC2086
1642           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1643         fi
1644         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1645         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1646       else
1647         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1648           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1649           # shellcheck disable=SC2086
1650           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1651         fi
1652         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1653         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1654       fi
1655     else
1656       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1657       case "${_opt_filesystem}" in
1658         f2fs)
1659           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1660           ;;
1661         xfs)
1662           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1663           ;;
1664         # NOTE - we might need to distinguish between further filesystems
1665         *)
1666           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1667           ;;
1668       esac
1669
1670       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1671       rm -f "${MNTPOINT}/tmp/core.img"
1672     fi
1673   fi
1674
1675   # workaround for Debian bug #918590 with lvm + udev:
1676   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1677   if [ -d /run/udev ] ; then
1678     einfo "Setting up bind-mount /run/udev"
1679     mkdir -p "${MNTPOINT}"/run/udev
1680     mount --bind /run/udev "${MNTPOINT}"/run/udev
1681     eend $?
1682   fi
1683
1684   if [ -n "${BOOT_APPEND}" ] ; then
1685     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1686     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1687   fi
1688
1689   einfo "Updating grub configuration file."
1690   chroot "${MNTPOINT}" update-grub
1691   chroot "${MNTPOINT}" sync
1692
1693   case "$RELEASE" in
1694     jessie)
1695       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1696       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1697       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1698       ;;
1699   esac
1700
1701   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1702     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1703     ewarn "Please note that your system might NOT be able to properly boot."
1704   elif [ -z "$ARM_EFI_TARGET" ]; then
1705     einfo "Adjusting grub.cfg for successful boot sequence."
1706     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1707   fi
1708
1709   # workaround for Debian bug #918590 with lvm + udev:
1710   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1711   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1712     einfo "Unmounting bind-mount /run/udev"
1713     umount "${MNTPOINT}"/run/udev
1714     eend $?
1715   fi
1716
1717   umount "${MNTPOINT}"/proc
1718   umount "${MNTPOINT}"/sys
1719   umount "${MNTPOINT}"/dev/pts
1720   try_umount 3 "${MNTPOINT}"/dev
1721
1722   if [ -n "$VMEFI" ]; then
1723     umount "${MNTPOINT}"/boot/efi
1724   fi
1725
1726 }
1727 # }}}
1728
1729 # unmount VM image {{{
1730 umount_target() {
1731   if [ -z "${VIRTUAL}" ] ; then
1732      return 0
1733   fi
1734
1735   if [ -n "${ARM_EFI_TARGET}" ]; then
1736     umount "${MNTPOINT}/boot/efi"
1737   fi
1738
1739   umount "${MNTPOINT}"
1740   kpartx -d "${ORIG_TARGET}" >/dev/null
1741   # Workaround for a bug in kpartx which doesn't clean up properly,
1742   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1743   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1744     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1745   fi
1746 }
1747 # }}}
1748
1749 # install main chroot {{{
1750 debootstrap_system() {
1751   if [ "$_opt_nodebootstrap" ]; then
1752      einfo "Skipping debootstrap as requested."
1753      return
1754   fi
1755
1756   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1757     :
1758   else
1759     eerror "Error: $MNTPOINT not mounted, can not continue."
1760     eend 1 ; exit 1
1761   fi
1762
1763   if [ -n "$ISO" ] ; then
1764     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1765     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1766     # shellcheck disable=SC2086
1767     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1768     RC=$?
1769   else
1770     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1771     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1772     # shellcheck disable=SC2086
1773     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1774     RC=$?
1775   fi
1776
1777   if [ $RC -ne 0 ] ; then
1778     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1779       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1780       einfo "Presenting last ten lines of debootstrap.log:"
1781       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1782       einfo "End of debootstrap.log"
1783     fi
1784   fi
1785
1786   eend $RC
1787 }
1788 # }}}
1789
1790 # prepare chroot via chroot-script {{{
1791 preparechroot() {
1792   einfo "Preparing chroot system"
1793
1794   # provide variables to chroot system
1795   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1796   touch "$CHROOT_VARIABLES"
1797   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1798   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1799   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1800   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1801   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1802   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1803   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1804   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1805   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1806   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1807   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1808   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1809   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1810   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1811   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1812   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1813   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1814   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1815   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1816   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1817   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1818   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1819   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1820   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1821   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1822   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1823   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1824   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1825   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1826   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1827   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1828   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1829   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1830   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1831   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1832   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1833   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1834   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1835   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1836   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1837   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1838   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1839   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1840   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1841   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1842   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1843   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1844   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1845   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1846
1847   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1848   chmod 755 "${MNTPOINT}"/bin/chroot-script
1849   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1850
1851   # make sure we have our files for later use via chroot-script
1852   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1853   # make sure we adjust the configuration variables accordingly:
1854   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1855   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1856   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1857
1858   # install notes:
1859   if [ -n "$INSTALL_NOTES" ] ; then
1860      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1861   fi
1862
1863   # package selection:
1864   if [ "$PACKAGES" = 'yes' ] ; then
1865     PACKAGES_FILE="packages"
1866
1867     if [ "$ARCH" = 'arm64' ]; then
1868       PACKAGES_FILE="packages-arm64"
1869     fi
1870
1871     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1872       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1873   fi
1874
1875   # debconf preseeding:
1876   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1877   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1878     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1879
1880   # copy scripts that should be executed inside the chroot:
1881   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1882   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1883     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1884     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1885   }
1886
1887   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1888   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1889
1890   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1891
1892   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1893   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1894
1895   # setup default locales
1896   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1897
1898   # copy any existing files to chroot
1899   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1900   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1901   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1902   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1903   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1904   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1905   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1906
1907   # network setup
1908   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1909
1910 # Include files from /etc/network/interfaces.d when using
1911 # ifupdown v0.7.44 or newer:
1912 #source-directory /etc/network/interfaces.d
1913
1914 auto lo
1915 iface lo inet loopback
1916
1917 allow-hotplug eth0
1918 iface eth0 inet dhcp
1919 "
1920
1921   # add dhcp setting for Predictable Network Interface Names
1922   if [ -x /bin/udevadm ]; then
1923     tmpfile=$(mktemp)
1924     for interface in /sys/class/net/*; do
1925       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1926       # skip virtual devices, like bridges, vboxnet,...
1927       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1928         continue
1929       fi
1930
1931       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1932       # use and stop on first match to have same behavior as udev's link_config_apply()
1933       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1934         if grep -q "${property}" "${tmpfile}" ; then
1935           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1936           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1937 allow-hotplug ${interface}
1938 iface ${interface} inet dhcp
1939 "
1940           break
1941         fi
1942       done
1943     done
1944     rm -f "${tmpfile}"
1945   fi
1946
1947   if [ -n "$NOINTERFACES" ] ; then
1948     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1949   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1950     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1951     mkdir -p "${MNTPOINT}/etc/network"
1952     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1953     # shellcheck disable=SC2320
1954     eend $?
1955   elif [ -n "$VIRTUAL" ] ; then
1956     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1957     mkdir -p "${MNTPOINT}/etc/network"
1958     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1959     # shellcheck disable=SC2320
1960     eend $?
1961   elif [ -r /etc/network/interfaces ] ; then
1962     einfo "Copying /etc/network/interfaces from host to target system"
1963     mkdir -p "${MNTPOINT}/etc/network"
1964     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1965     eend $?
1966   else
1967     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1968     mkdir -p "${MNTPOINT}/etc/network"
1969     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1970     # shellcheck disable=SC2320
1971     eend $?
1972   fi
1973
1974   # install config file providing some example entries
1975   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1976     mkdir -p "${MNTPOINT}/etc/network"
1977     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1978   fi
1979
1980   if [ -n "${SSHCOPYID}" ] ; then
1981     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1982     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1983     if ssh-add -L >/dev/null 2>&1 ; then
1984       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1985       mkdir -p "${MNTPOINT}"/root/.ssh
1986       chmod 0700 "${MNTPOINT}"/root/.ssh
1987       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1988         eerror "Error: executing 'ssh-add -L' failed."
1989         eend 1
1990         bailout 1
1991       fi
1992     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1993       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1994       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1995       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1996       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1997         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1998         eend 1
1999         bailout 1
2000       fi
2001     else
2002       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
2003       eend 1
2004       bailout 1
2005     fi
2006   fi
2007
2008   if [ -n "${SSHCOPYAUTH}" ] ; then
2009     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
2010
2011     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
2012       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
2013       eend 1
2014       bailout 1
2015     fi
2016
2017     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
2018     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
2019     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
2020     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
2021     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
2022       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
2023       eend 1
2024       bailout 1
2025     fi
2026   fi
2027
2028   if [ -d /run/udev ] ; then
2029     einfo "Setting up bind-mount /run/udev"
2030     mkdir -p "${MNTPOINT}"/run/udev
2031     mount --bind /run/udev "${MNTPOINT}"/run/udev
2032     eend $?
2033   fi
2034 }
2035 # }}}
2036
2037 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
2038 execute_pre_scripts() {
2039   # make sure hostname is set even before chroot-script get executed
2040   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
2041
2042   # make sure we have $MNTPOINT available for our scripts
2043   export MNTPOINT
2044
2045   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
2046     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
2047     for script in "${pre_scripts}"/* ; do
2048       if [ -x "$script" ] ; then
2049         einfo "Executing pre-script $script"
2050         "$script" ; eend $?
2051       fi
2052     done
2053   fi
2054 }
2055 # }}}
2056
2057 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2058 execute_post_scripts() {
2059   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2060   export MNTPOINT
2061   export TARGET_HOSTNAME=$HOSTNAME
2062
2063   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2064     # legacy support for /etc/debootstrap/scripts/
2065     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2066     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2067   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2068     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2069   fi
2070
2071   if [ -n "$post_scripts" ] ; then
2072     for script in "${post_scripts}"/* ; do
2073       if [ -x "$script" ] ; then
2074         einfo "Executing post-script $script"
2075         "$script" ; eend $?
2076       fi
2077     done
2078   fi
2079 }
2080 # }}}
2081
2082 # unmount mountpoint {{{
2083 try_umount() {
2084   local tries=$1
2085   local mountpoint="$2"
2086
2087   for (( try=1; try<=tries; try++ )); do
2088     if [[ ${try} -eq ${tries} ]]; then
2089       # Last time, show errors this time
2090       umount "${mountpoint}" && return 0
2091     else
2092       # Not last time, hide errors until fatal
2093       if umount "${mountpoint}" 2>/dev/null ; then
2094         return 0
2095       else
2096         sleep 1
2097       fi
2098     fi
2099   done
2100   return 1  # Tried enough
2101 }
2102 # }}}
2103
2104 # execute chroot-script {{{
2105 chrootscript() {
2106   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2107     mount_target
2108   fi
2109
2110   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2111     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2112     eend 1
2113   else
2114     einfo "Executing chroot-script now"
2115     mount -t devtmpfs udev "${MNTPOINT}"/dev
2116     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2117     if [ "$DEBUG" = "true" ] ; then
2118       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
2119     else
2120       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
2121     fi
2122     try_umount 3 "$MNTPOINT"/dev/pts
2123     try_umount 3 "$MNTPOINT"/dev
2124     eend $RC
2125   fi
2126
2127   # finally get rid of chroot-script again, there's no good reason to
2128   # keep it on the installed system
2129   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2130     einfo "Removing chroot-script again"
2131     rm -f "${MNTPOINT}/bin/chroot-script"
2132     eend $?
2133   else
2134     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2135   fi
2136 }
2137 # }}}
2138
2139 # unmount $MNTPOINT {{{
2140 umount_chroot() {
2141
2142   # display installation notes:
2143   if [ -n "$INSTALL_NOTES" ] ; then
2144      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2145   fi
2146
2147   if [ -n "$ISODIR" ] ; then
2148      if grep -q "$ISODIR" /proc/mounts ; then
2149         einfo "Unmount $MNTPOINT/$ISODIR"
2150         umount "$MNTPOINT/$ISODIR"
2151         eend $?
2152      fi
2153   fi
2154
2155   if grep -q "$MNTPOINT" /proc/mounts ; then
2156     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
2157       einfo "Unmounting bind-mount /run/udev"
2158       umount "${MNTPOINT}"/run/udev
2159       eend $?
2160     fi
2161
2162      if [ -n "$PARTITION" ] ; then
2163         einfo "Unmount $MNTPOINT"
2164         umount "$MNTPOINT"
2165         eend $?
2166      fi
2167   fi
2168 }
2169 # }}}
2170
2171 # execute filesystem check {{{
2172 fscktool() {
2173  if [ -n "$VIRTUAL" ] ; then
2174    einfo "Skipping filesystem check because we deploy a virtual machine."
2175    return 0
2176  fi
2177
2178  if [ "$FSCK" = 'yes' ] ; then
2179    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2180    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2181    "$FSCKTOOL" "$TARGET"
2182    eend $?
2183  fi
2184 }
2185 # }}}
2186
2187 # get rid of grml-debootstrap config files {{{
2188 remove_configs() {
2189   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2190     return 0
2191   fi
2192
2193   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2194     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2195     return 0
2196   fi
2197
2198   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2199   rm -rf "${MNTPOINT}"/etc/debootstrap/
2200   eend $?
2201 }
2202 # }}}
2203
2204 # now execute all the functions {{{
2205 for i in format_efi_partition prepare_vm mkfs tunefs \
2206          mount_target mountpoint_to_blockdevice debootstrap_system \
2207          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2208          remove_configs umount_chroot grub_install umount_target fscktool ; do
2209     if stage "${i}" ; then
2210       "$i"
2211       if [ $? -eq 0 ]; then
2212         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
2213       else
2214         bailout 2 "$i"
2215       fi
2216     fi
2217 done
2218
2219 cleanup
2220 # }}}
2221
2222 # end dialog of autoinstallation {{{
2223 if [ -n "$AUTOINSTALL" ] ; then
2224    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2225 Automatically rebooting in 10 seconds.
2226
2227 Choose Cancel to skip rebooting." 10 60 10 ; then
2228      noeject noprompt reboot
2229   fi
2230 else
2231    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2232 fi
2233 # }}}
2234
2235 ## END OF FILE #################################################################
2236 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2